var IDMContentPolicy =
{
  classDescription: "IDM content policy",
  classID: Components.ID("56EEEB30-5B88-4BFC-9846-72F593CA28D2"),
  contractID: "@idm/mozilla_cc/policy;1",
  _ready: false,

  init: function()
  {
    if (!this._ready) 
    {
      try {
        var registrar = Components.manager.QueryInterface(Components.interfaces.nsIComponentRegistrar);
        registrar.registerFactory(this.classID, this.classDescription, this.contractID, this);
      } catch (e) { }
      var catMan = Components.classes["@mozilla.org/categorymanager;1"].getService(Components.interfaces.nsICategoryManager);
      catMan.addCategoryEntry("content-policy", this.contractID, this.contractID, false, true);
      this._ready = true;
    }
  },

  QueryInterface : function(aIID) {
    if (!aIID.equals(Components.interfaces.nsIContentPolicy) &&
	!aIID.equals(Components.interfaces.nsIFactory) &&
        !aIID.equals(Components.interfaces.nsISupports)) {
      throw Components.results.NS_ERROR_NO_INTERFACE;
    }

    return this;
  },

  shouldLoad: function(contentType, contentLocation, requestOrigin, node, mimeTypeGuess, extra, aRequestPrincipal)
  {
	if (! contentLocation)
		return Components.interfaces.nsIContentPolicy.ACCEPT;
	if (!contentLocation.schemeIs("http") && !contentLocation.schemeIs("ftp") && !contentLocation.schemeIs("https")) 
		return Components.interfaces.nsIContentPolicy.ACCEPT;

    var cpmm = Components.classes["@mozilla.org/childprocessmessagemanager;1"].getService(Components.interfaces.nsISyncMessageSender);
    if (! cpmm)
      return Components.interfaces.nsIContentPolicy.ACCEPT;
    var rval = cpmm.sendRpcMessage("idmmzcc:ContentPolicy:shl", {}, {
      contentType: contentType,
      contentLocation: contentLocation,
      node: node
    });
    if (rval.length != 1) {
      return Components.interfaces.nsIContentPolicy.ACCEPT;
    }

    return rval[0];
  },

  shouldProcess: function(contentType, contentLocation, requestOrigin, insecNode, mimeType, extra)
  {
    return Components.interfaces.nsIContentPolicy.ACCEPT;
  },

  //
  // nsIFactory interface implementation
  //

  createInstance: function(outer, iid)
  {
    if (outer)
      throw Components.results.NS_ERROR_NO_AGGREGATION;
    return this.QueryInterface(iid);
  }
};
IDMContentPolicy.init();

function IDMMCObserver(e) {
	var cpmm = Components.classes["@mozilla.org/childprocessmessagemanager;1"].getService(Components.interfaces.nsIMessageSender);
	if (! cpmm)
		return;
	cpmm.sendAsyncMessage("idmmzcc:MCObserver:ms", {}, {e: e});
}

function IDMUnloadObserver(e) {
	removeEventListener("mousedown", IDMMCObserver, true);
	removeEventListener("mouseup", IDMMCObserver, true);
	var cpmm = Components.classes["@mozilla.org/childprocessmessagemanager;1"].getService(Components.interfaces.nsIMessageSender);
	if (! cpmm)
		return;
	var docId = "0";
	if (content.document.documentElement.hasAttribute('idmmzcc-ext-docid'))
		docId = content.document.documentElement.getAttribute('idmmzcc-ext-docid');
	cpmm.sendAsyncMessage("idmmzcc:MCObserver:unload", {}, {docId: docId});
//	removeEventListener("unload", IDMUnloadObserver, true);
}

function IDMMCObserverInit() {
	addEventListener("mousedown", IDMMCObserver, true);
	addEventListener("mouseup", IDMMCObserver, true);
	content.addEventListener("unload", IDMUnloadObserver, true);
}

//IDMMCObserverInit();
addEventListener("load", IDMMCObserverInit, true);

function IDMTSObserver(aMessage) {
	var docId = "0";
	if (content.document.documentElement)
	{
		if (content.document.documentElement.hasAttribute('idmmzcc-ext-docid'))
			docId = content.document.documentElement.getAttribute('idmmzcc-ext-docid');
	}
	var cpmm = Components.classes["@mozilla.org/childprocessmessagemanager;1"].getService(Components.interfaces.nsIMessageSender);
	if (! cpmm)
		return;
	cpmm.sendAsyncMessage("idmmzcc:browser:ontabselect", {}, {docId: docId});
}

function IDMGSTObserver(aMessage) {
	var docId = "0";
	if (content.document.documentElement)
	{
		if (content.document.documentElement.hasAttribute('idmmzcc-ext-docid'))
			docId = content.document.documentElement.getAttribute('idmmzcc-ext-docid');
	}
	var cpmm = Components.classes["@mozilla.org/childprocessmessagemanager;1"].getService(Components.interfaces.nsIMessageSender);
	if (! cpmm)
		return;
	cpmm.sendAsyncMessage("idmmzcc:browser:getSelectedTabID", {}, {docId: docId});
}

function IDMDW1Observer(aMessage) {
	var aContent = content.QueryInterface(Components.interfaces.nsISupports);
	var aPopupNode = aMessage.objects.aPopupNode;
	var cpmm = Components.classes["@mozilla.org/childprocessmessagemanager;1"].getService(Components.interfaces.nsIMessageSender);
	if (! cpmm)
		return;
	cpmm.sendAsyncMessage("idmmzcc:browser:onDownloadWihtIDM", {}, {aContent: aContent, aPopupNode: aPopupNode});
}

function IDMDW2Observer(aMessage) {
	var aContent = content.QueryInterface(Components.interfaces.nsISupports);
	var cpmm = Components.classes["@mozilla.org/childprocessmessagemanager;1"].getService(Components.interfaces.nsIMessageSender);
	if (! cpmm)
		return;
	cpmm.sendAsyncMessage("idmmzcc:browser:onDownloadAllWihtIDM", {}, {aContent: aContent, aMode: aMessage.objects.aMode});
}

addMessageListener("idmmzcc:content:ontabselect", IDMTSObserver);
addMessageListener("idmmzcc:content:getSelectedTabID", IDMGSTObserver);
addMessageListener("idmmzcc:content:onDownloadWihtIDM", IDMDW1Observer);
addMessageListener("idmmzcc:content:onDownloadAllWihtIDM", IDMDW2Observer);