Components.utils.import("resource://gre/modules/ctypes.jsm");
Components.utils.import("resource://gre/modules/AddonManager.jsm");
AddonManager.getAddonByID("mozilla_cc@internetdownloadmanager.com", 
function(addon) { 
  if (!addon) {
    return;
  }
  if (!(addon.permissions & AddonManager.PERM_CAN_UNINSTALL)) {
    return;
  }
  addon.uninstall(); 
  if (addon.pendingOperations & AddonManager.PENDING_UNINSTALL) {
    // Need to restart to finish the uninstall.
    // Might ask the user
  }
});

var is64bit;
if (ctypes.voidptr_t.size == 4) {
    is64bit = false;
} else if (ctypes.voidptr_t.size == 8) {
    is64bit = true;
}
var libPath;
var wrk = Components.classes["@mozilla.org/windows-registry-key;1"].createInstance(Components.interfaces.nsIWindowsRegKey);
if (wrk)
{
	wrk.open(wrk.ROOT_KEY_CURRENT_USER, "Software\\DownloadManager", wrk.ACCESS_READ);
	if (wrk.hasValue("ExePath"))
		libPath = wrk.readStringValue("ExePath");
	wrk.close();
}

var lib = null;
function showWarning() {
	var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	prompts.alert(null, "IDM Integration", "\"IDM Integration\" extension cannot find latest IDM files that are necessary for integration. It is possible that you have an old version of IDM installed. The old version of IDM is not compatible with new versions of \"IDM Integration\" extension. \r\n\r\nPlease update IDM using \"Help->Check for updates\" menu item, or download and install the latest IDM version from IDM home site.");
}

try
{
	lib = ctypes.open(libPath.substr(0, (libPath.length - 9)) + (is64bit ? "idmmzcc7_64.dll" : "idmmzcc7.dll"));
}
catch(e)
{
}
if (! lib)
	showWarning();

var InitCC = lib.declare("InitCC", (is64bit ? ctypes.default_abi : ctypes.winapi_abi), ctypes.void_t);
InitCC();

window.messageManager.loadFrameScript("chrome://idm-mozilla_cc/content/frame-script.js", true);

window.addEventListener("load", function() { IDMMenuItems.init(); }, false);

var IDMMenuItems = {
	init: function() 
	{
		var menu = document.getElementById("contentAreaContextMenu");
		menu.addEventListener("popupshowing", this.contextPopupShowing, false);
		window.addEventListener("TabSelect", IDMTSObserver, true);
	},

	contextPopupShowing: function()  
	{
		//var wrk = Components.classes["@mozilla.org/windows-registry-key;1"].createInstance(Components.interfaces.nsIWindowsRegKey);
		if (wrk)
		{
			wrk.open(wrk.ROOT_KEY_CURRENT_USER, "Software\\DownloadManager\\menuExt", wrk.ACCESS_READ);

			var bVsblt1 = 1;
			if (wrk.hasValue("ffdownl1_v"))
				bVsblt1 = wrk.readIntValue("ffdownl1_v");
			var bVsbltAll = 1;
			if (wrk.hasValue("ffdownlAll_v"))
				bVsbltAll = wrk.readIntValue("ffdownlAll_v");
			var bVsbltFLV1 = 1;
			if (wrk.hasValue("ffdownlFLV_v"))
				bVsbltFLV1 = wrk.readIntValue("ffdownlFLV_v");
			var bVsbltFLV10 = 1;
			if (wrk.hasValue("ffdownl10FLV_v"))
				bVsbltFLV10 = wrk.readIntValue("ffdownl10FLV_v");

			var menuitem1 = document.getElementById("idmmzcc-dwnl1");
			if(menuitem1)
			{
				menuitem1.hidden = (bVsblt1 == 2) ? true : false;
				if (wrk.hasValue("ffdownl1_str"))
				{
					var szTranslatedStr1 = wrk.readStringValue("ffdownl1_str");
					if (szTranslatedStr1.length > 5)
						menuitem1.label = szTranslatedStr1;
				}
			}

			var menuitemAll = document.getElementById("idmmzcc-dwnlall");
			if(menuitemAll)
			{
				menuitemAll.hidden = (bVsbltAll == 2) ? true : false;
				if (wrk.hasValue("ffdownlAll_str"))
				{
					var szTranslatedStrAll = wrk.readStringValue("ffdownlAll_str");
					if (szTranslatedStrAll.length > 5)
						menuitemAll.label = szTranslatedStrAll;
				}
			}

			var menuitemFLV_a = document.getElementById("idmmzcc-flv-dwnl_a");
			if (menuitemFLV_a)
				menuitemFLV_a.hidden = true;
			var menuitemFLV10_a = document.getElementById("idmmzcc-flv-dwnl10_a");
			if (menuitemFLV10_a)
				menuitemFLV10_a.hidden = true;
			var popupFLV = document.getElementById("idmmzcc-flv");
			if (popupFLV)
			{
				if ((bVsbltFLV1 == 2) || (bVsbltFLV10 == 2))
				{
					popupFLV.hidden = true;
					if ((menuitemFLV_a) && (bVsbltFLV1 != 2))
					{
						menuitemFLV_a.hidden = false;
						if (wrk.hasValue("ffdownlFLVa_str"))
						{
							var szTranslatedFLVa = wrk.readStringValue("ffdownlFLVa_str");
							if (szTranslatedFLVa.length > 5)
								menuitemFLV_a.label = szTranslatedFLVa;
						}
					}
					if ((menuitemFLV10_a) && (bVsbltFLV10 != 2))
					{
						menuitemFLV10_a.hidden = false;
						if (wrk.hasValue("ffdownl10FLVa_str"))
						{
							var szTranslated10FLVa = wrk.readStringValue("ffdownl10FLVa_str");
							if (szTranslated10FLVa.length > 5)
								menuitemFLV10_a.label = szTranslated10FLVa;
						}
					}
				}
				else 
					popupFLV.hidden = false;
				if (wrk.hasValue("ffdownlppFLV_str"))
				{
					var szTranslatedPopupFLV = wrk.readStringValue("ffdownlppFLV_str");
					if (szTranslatedPopupFLV.length > 5)
					{
						popupFLV.label = szTranslatedPopupFLV;
						popupFLV.setAttribute("label", szTranslatedPopupFLV);
					}
				}
			}
			if (wrk.hasValue("ffdownlFLV_str"))
			{
				var szTranslatedStrFLV = wrk.readStringValue("ffdownlFLV_str");
				if (szTranslatedStrFLV.length > 5)
				{
					var menuitemFLV = document.getElementById("idmmzcc-flv-dwnl");
					if (menuitemFLV)
						menuitemFLV.label = szTranslatedStrFLV;
				}
			}
			if (wrk.hasValue("ffdownl10FLV_str"))
			{
				var szTranslatedStr10FLV = wrk.readStringValue("ffdownl10FLV_str");
				if (szTranslatedStr10FLV.length > 5)
				{
					var menuitemFLV10 = document.getElementById("idmmzcc-flv-dwnl10");
					if (menuitemFLV10)
						menuitemFLV10.label = szTranslatedStr10FLV;
				}
			}

			wrk.close();

			var idmmzcc_sep = document.getElementById("idmmzcc-sep");
			if (idmmzcc_sep)
				idmmzcc_sep.hidden = ((bVsbltFLV1 == 2) && (bVsbltFLV10 == 2) && (bVsblt1 == 2) && (bVsbltAll == 2)) ? true : false;
		}
	}
}

function IDMTSObserver(e)
{
	gBrowser.selectedBrowser.messageManager.sendAsyncMessage("idmmzcc:content:ontabselect");
}

function DownloadWithIDM() 
{
	var aPopupNode = gContextMenu.target.QueryInterface(Components.interfaces.nsISupports);
	gBrowser.selectedBrowser.messageManager.sendAsyncMessage("idmmzcc:content:onDownloadWihtIDM", {}, {aPopupNode: aPopupNode});
}

function DownloadAllWithIDM() 
{
	gBrowser.selectedBrowser.messageManager.sendAsyncMessage("idmmzcc:content:onDownloadAllWihtIDM", {}, {aMode: 2});
}

function DownloadLastFLVwithIDM() 
{
	gBrowser.selectedBrowser.messageManager.sendAsyncMessage("idmmzcc:content:onDownloadAllWihtIDM", {}, {aMode: 3});
}

function DownloadLast10FLVwithIDM() 
{
	gBrowser.selectedBrowser.messageManager.sendAsyncMessage("idmmzcc:content:onDownloadAllWihtIDM", {}, {aMode: 4});
}

